<?php
/**
 * The template for displaying Author bios.
 *
 * @package WordPress
 * @subpackage Beverly
 * @since Beverly 1.0
 */
?>

<?php $curauth = (get_query_var('author_name')) ? get_user_by('slug', get_query_var('author_name')) : get_userdata(get_query_var('author')); ?>
<div class = "author-bio">
	<table class = "author-bio-table">
		<tr>
			<td class = "author-names">
				<?php if($curauth->user_firstname || $curauth->user_lastname) { ?>
					<div class = "author-fullname"><?php echo $curauth->user_firstname.' '.$curauth->user_lastname;?></div>
				<?php } ?>
				<div class = "author-nickname"><?php echo $curauth->nickname; ?></div>
			</td>
			<td class = "author-avatar">
				<?php echo get_avatar($curauth->ID,70); ?>
			</td>
		</tr>
	</table>
	<div class = "author-description"><?php echo $curauth->description; ?></div>
	<div class = "author-meta">
		<span class = "posts-count"><?php echo count_user_posts($curauth->ID); ?></span> <span class = "comments-count"><?php echo get_comments(array('count'=>true,'user_id'=>$curauth->ID,'status'=>'approve')); ?></span>
	</div>
	<div class = "author-links">
		<?php if($curauth->user_url) { ?>
			<a href = "<?php echo $curauth->user_url; ?>" class = "author-links-website" title = "User Website" target = "blank"><span class = "icon-website"></span></a>
		<?php } ?>
	</div>
</div>