<?php
remove_shortcode("gallery");
add_shortcode("gallery", "beverly_gallery_shortcode");

function beverly_gallery_shortcode($attr)
{
	$post = get_post();
	static $instance = 0;
	$instance++;
	if (!empty($attr['ids'])) {
		if (empty($attr['orderby']))
			$attr['orderby'] = 'post__in';
		$attr['include'] = $attr['ids'];
	}
	$output = apply_filters('post_gallery', '', $attr);
	if ($output != '')
		return $output;
	if (isset($attr['orderby'])) {
		$attr['orderby'] = sanitize_sql_orderby($attr['orderby']);
		if (!$attr['orderby'])
			unset($attr['orderby']);
	}
	extract(shortcode_atts(array(
		'order' => 'ASC',
		'orderby' => 'menu_order ID',
		'id' => $post ? $post->ID : 0,
		'itemtag' => 'div',
		'icontag' => 'div',
		'captiontag' => 'div',
		'columns' => 3,
		'size' => 'medium',
		'include' => '',
		'exclude' => '',
		'link' => '',
		'name' => ''
	), $attr, 'gallery'));
	$id = intval($id);
	if ('RAND' == $order)
		$orderby = 'none';
	if (!empty($include)) {
		$_attachments = get_posts(array(
			'include' => $include,
			'post_status' => 'inherit',
			'post_type' => 'attachment',
			'post_mime_type' => 'image',
			'order' => $order,
			'orderby' => $orderby
		));
		$attachments  = array();
		foreach ($_attachments as $key => $val) {
			$attachments[$val->ID] = $_attachments[$key];
		}
	} elseif (!empty($exclude)) {
		$attachments = get_children(array(
			'post_parent' => $id,
			'exclude' => $exclude,
			'post_status' => 'inherit',
			'post_type' => 'attachment',
			'post_mime_type' => 'image',
			'order' => $order,
			'orderby' => $orderby
		));
	} else {
		$attachments = get_children(array(
			'post_parent' => $id,
			'post_status' => 'inherit',
			'post_type' => 'attachment',
			'post_mime_type' => 'image',
			'order' => $order,
			'orderby' => $orderby
		));
	}
	if (empty($attachments))
		return '';
	if (is_feed()) {
		$output = "\n";
		foreach ($attachments as $att_id => $attachment)
			$output .= wp_get_attachment_link($att_id, $size, true) . "\n";
		return $output;
	}
	$itemtag    = tag_escape($itemtag);
	$captiontag = tag_escape($captiontag);
	$icontag    = tag_escape($icontag);
	$valid_tags = wp_kses_allowed_html('post');
	if (!isset($valid_tags[$itemtag]))
		$itemtag = 'dl';
	if (!isset($valid_tags[$captiontag]))
		$captiontag = 'dd';
	if (!isset($valid_tags[$icontag]))
		$icontag = 'dt';
	$columns       = intval($columns);
	$itemwidth     = $columns > 0 ? 794 / $columns : 225;
	$title = ($name ? sanitize_text_field($name) : get_post_format_string('gallery'));
	$selector      = ($name ? beverly_nice_hashtag($name) : "gallery-{$instance}");
	$gallery_style = $gallery_div = '';
	$size_class    = sanitize_html_class($size);
	$gallery_div   = "<div id={$selector} class='gallery galleryid-{$id} gallery-columns-{$columns} gallery-size-{$size_class}'>";
	$output        = apply_filters('gallery_style', $gallery_style . "\n\t\t" . $gallery_div);
	$i             = 0;
	foreach ($attachments as $id => $attachment) {
		if (!empty($link) && 'file' === $link)
			$image_output = wp_get_attachment_link($id, $size, false, false);
		elseif (!empty($link) && 'none' === $link)
			$image_output = wp_get_attachment_image($id, $size, false);
		else
			$image_output = wp_get_attachment_link($id, $size, true, false);
		$image_meta  = wp_get_attachment_metadata($id);
		$orientation = '';
		if (isset($image_meta['height'], $image_meta['width']))
			$orientation = ($image_meta['height'] > $image_meta['width']) ? 'portrait' : 'landscape';
		$output .= "<{$itemtag} class='gallery-item'>";
		$output .= "
                        <{$icontag} class='gallery-icon {$orientation}'>
                                $image_output
                        </{$icontag}>";
		if ($captiontag && trim($attachment->post_excerpt)) {
			$output .= "
                                <{$captiontag} class='wp-caption-text gallery-caption'>
                                " . wptexturize($attachment->post_excerpt) . "
                                </{$captiontag}>";
		}
		$output .= "</{$itemtag}>";
	}
	$output .= "<br style='clear: both;'/></div>";
	global $is_parsing_img;
	if(!is_singular()) {
	if ( !$is_parsing_img ) {
		if($name) {
			$output = '<a href = "' . get_permalink() . '#'.$selector.'">' . $title . ' - ' . count($attachments) . '<span class = "icon-gallery"></span></a><br/>';
		} else {
			$output = '<a href = "' . get_permalink().'">' . $title . ' - ' . count($attachments) . ' <span class = "icon-gallery"></span></a><br/>';
		}
	}
	}
	return $output;
}
?>