<?php
function beverly_fonts_url() {
	$fonts_url = '';
	$source_sans_pro = _x( 'on', 'Source Sans Pro font: on or off', 'Beverly' );
	if ( 'off' !== $source_sans_pro ) {
		$font_families = array();
		$font_families[] = 'Source Sans Pro:300,400,700,300italic,400italic,700italic';
		$query_args = array(
			'family' => urlencode( implode( '|', $font_families ) ),
			'subset' => urlencode( 'latin,latin-ext' ),
		);
		$fonts_url = add_query_arg( $query_args, "//fonts.googleapis.com/css" );
	}
	return $fonts_url;
}

function beverly_format_comment($comment, $args, $depth) {
	$GLOBALS['comment'] = $comment;
	extract($args, EXTR_SKIP);
	$tag = 'div';
	$add_below = 'comment';
	?>
	<div <?php comment_class(array(empty( $args['has_children'] ) ? '' : 'parent')) ?> id="comment-<?php comment_ID() ?>">
	<div class = "comment-inner">
	<table class = "author-bio-table">
		<tr>
			<td class = "comment-meta">
			<div class = "comment-author"><?php comment_author(); ?></div>
			<div class = "comment-date"><?php comment_date(); ?></div>
			<?php edit_comment_link('','  ','' );?>
			<?php comment_reply_link(array_merge( $args, array('add_below' => $add_below, 'depth' => $depth, 'max_depth' => $args['max_depth']))) ?>
			</td>
			<td class = "author-avatar"><?php echo get_avatar(get_comment_ID(),70); ?></td>
		</tr>
	</table>
	<div class = "comment-content"><?php comment_text(); ?></div>
	<?php if ($comment->comment_approved == '0') : ?>
		<em class="comment-awaiting-moderation"><?php _e('Your comment is awaiting moderation.', 'Beverly') ?></em><br />
	<?php endif; ?>
	</div>
	<?php $child_comments = get_comments(array('parent' => get_comment_ID())); ?>
	<?php if($child_comments) { ?>
	<div class = "post-card-cell">
	<div class = "reply-btn btn"><span class = "icon-reply"></span><span class = "comment-childs"><?php echo sizeof($child_comments); ?></span></div>
	</div>
<?php }}

function beverly_get_post_parts() {
	$post_meta = get_post_meta(get_the_ID(), 'card_info', true);
	if(empty($post_meta)) {
		add_post_meta(get_the_ID(), 'card_info', get_option('beverly_def_val'));
		$post_meta = get_option('beverly_def_val');
	}
	return $post_meta;
}

function beverly_the_links() {
	echo '<div class = "post-card-cell link-list">';
	$hrefs = beverly_get_links();
	if(sizeof($hrefs) > 3) {
		$more_links = true;
		$hrefs = array_slice($hrefs,0,3);
	}
	foreach ($hrefs as $href) {
		echo '<li><a role = "link" href = "'.$href.'" target = "_blank">'.beverly_get_nice_url($href).'</a></li>';
	}
	if($more_links) echo '...';
	echo '</ul></div>';
}

function beverly_get_links( $content = false ){
	global $post;
	if(!$content) $content = $post->post_content;
	$dom = new DomDocument();
	@$dom->loadHTML($content);
	$urls = $dom->getElementsByTagName('a');
	$hrefs = array();
	foreach ($urls as $url) {
		$hrefs[] = $url->getAttribute('href');
	}
	return $hrefs;
}

function beverly_get_first_quote( $content = false ) {
	global $post;
	if(!$content) $content = $post->post_content;
	$dom = new DomDocument();
	@$dom->loadHTML('<?xml encoding="'.get_bloginfo('charset').'">'.$content);
	$quotes = $dom->getElementsByTagName('q');
	if($quotes->length == 0) $quotes = $dom->getElementsByTagName('blockquote');
	if($quotes->length == 0) return "";
	return $quotes->item(0);
}

function beverly_the_quote() {
	echo '<div class = "post-card-cell"><blockquote>';
	$quote = beverly_get_first_quote();
	echo $quote->textContent;
	echo '</blockquote></div>';
}

function beverly_get_nice_url($url) {
	$parse = parse_url($url);
	return $parse['host'];
}

function beverly_the_password() {
	if(post_password_required()) echo '<div class = "post-card-cell password-required">Password required</div>';
}

function beverly_the_date_archive() {
	echo '<a href="'.get_month_link( get_the_time('Y'), get_the_time('m') ).'">'.get_the_date().'</a>';
}

function beverly_post_card_title() {
	$title = get_the_title();
	if($title)
		echo '<h1 class = "post-permalink"><a href = "'.get_permalink().'">'.get_the_title().'</a></h1>';
}

function beverly_the_post_info() {
	global $post;
	$card_info = beverly_get_post_parts();
	$have_title = get_the_title() && $card_info['show_title'];
	$have_post_meta = $card_info['show_author'] || $card_info["show_pubdate"] || $card_info['show_comments'] || $card_info['show_category'] || has_post_format("gallery");
	if($have_title || $have_post_meta) {
	echo '<div class = "post-card-cell">';
	if($card_info['show_title']) {
		beverly_post_card_title();
	}
	if($have_post_meta)  {
	echo '<div class = "post-meta">';
	$fullInfo = ($card_info['show_author'] && $card_info["show_pubdate"] && $card_info['show_comments'] && $card_info['show_category'] && get_post_type() != "page");
	if($fullInfo) echo '<span class = "post-meta-couple">';
	if($card_info['show_author']) {
		echo '<span class = "post-meta-cell">';
		the_author();
		echo '</span>';
	}
	if($card_info["show_pubdate"]) {
		echo '<span class = "post-meta-cell">';
		beverly_the_date_archive();
		echo '</span>';
	}
	if($fullInfo) echo '</span><span class = "post-meta-couple">';
	if($card_info['show_category'] && get_post_type() != "page") {
		echo '<span class = "category-list post-meta-cell">';
		the_category(', ');
		echo '</span>';
	}
	if ( has_post_format( 'gallery' )) {
		global $post;
    global $is_parsing_img;
    $is_parsing_img = true;
		$galleries = get_post_galleries_images( $post );
		$is_parsing_img = false;
    $i = 0;
		foreach($galleries as $gallery) {
			$i += count($gallery);
		}
		echo '<span class = "post-meta-cell"><span class = "icon-gallery images-count"></span>'.$i.'</span>';
	}

	if($card_info['show_comments']) {
		echo '<span class = "post-meta-cell"><a class = "comments-count" href = "'.get_permalink().'#comments">';
		comments_number('0', '1', '%');
		echo '</a></span>';
	}
	if($fullInfo) echo '</span>';
	echo '</div>';
	}
	echo '</div>';
	}
}

function beverly_settings_checkbox($id, $name, $db_value, $value, $label) {
	echo "<label for = '$id'><input id='$id' name = '$name' type='checkbox' ".checked($value , $db_value, false)."  value='$value'/> " . $label."</label><br />";
}

function beverly_sanitize_array($input) {
	foreach ($input as &$value) {
		$value = sanitize_text_field($value);
	}
	return $input;
}

function beverly_sanitize_codes($inputs) {
	// This theme doesn´t sanitize user own script due to functionality.
	$inputs['favicon_url'] = filter_var($inputs['favicon_url'], FILTER_SANITIZE_URL);
	$inputs['footer_script'] = sanitize_text_field($inputs['footer_script']);
	$inputs['own_styles'] = beverly_sanitize_css($inputs['own_styles']);
	return $inputs;
}

function beverly_get_first_oembed_url($content) {
	global $post;
	if(empty($content)) $content = $post->post_content;
	$matches = "";
	$oembed_providers = beverly_get_oembed_providers();
	foreach ($oembed_providers as $regex => $value) {
		preg_match($regex, $content, $matches);
		if(!empty($matches)) break;
	}
	return (empty($matches[0]) ? false : $matches[0]);
}

function beverly_the_oembed() {
	global $post;
	$card_info = beverly_get_post_parts();
	$oembed_url = beverly_get_first_oembed_url();
	if($card_info['show_media'] && $oembed_url) {
		echo wp_oembed_get($oembed_url);
	} else {
		the_post_thumbnail('medium');
	}
}

function beverly_get_first_img() {
  $img_array = beverly_get_first_n_imgs(1);
  if($img_array) return $img_array[0];
}

function beverly_get_first_img_url() {
	return beverly_get_first_n_imgs(1, true)[0];
}

function beverly_has_first_img() {
	return beverly_get_first_img() != "";	
}

function beverly_get_first_n_imgs($n = 3, $url = false) {
	global $is_parsing_img;
	$is_parsing_img = true;
	preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', do_shortcode(get_the_content()), $imgs);
	$is_parsing_img = false;
	if($url) return array_slice($imgs[1], 0, $n);
	return array_slice($imgs[0], 0, $n);
}

function beverly_get_oembed_providers( ) {
    require_once( ABSPATH . WPINC . '/class-oembed.php' );
    $oembed = _wp_oembed_get_object();
    return $oembed->providers;
}

function beverly_nice_hashtag($input, $replace = '-') {
	$return = trim(ereg_replace(' +', ' ', preg_replace('/[^a-zA-Z0-9\s]/', '', strtolower($input))));
	return str_replace(' ', $replace, $return);
}

function beverly_get_sticky_count() {
	return count(get_option('sticky_posts'));
}

function beverly_sticky_slider() {
	global $is_sticky;
	global $post;
	$is_sticky=true;
	$sticky_posts = get_option('sticky_posts');
	query_posts( array('post__in'=>$sticky_posts,'posts_per_page'=>6,'ignore_sticky_posts' => 1) );
	if(have_posts() && $sticky_posts) { ?>
		<div class = "right-box">
			<!-- sticky slider -->
			<div id = "sticky-top-box">
				<div id = "sticky-padding-box">
					<div id = "sticky-left-box" class = "media-box slot">
					<a id = "sticky-link" role = "link"></a>
						<?php while(have_posts()) {
							the_post();
							if(has_post_thumbnail()) {
								echo '<div class="img-attach">';
								the_post_thumbnail('large');
								echo '</div>';
							} elseif(beverly_has_first_img()) {
								echo '<div class="img-attach">'.beverly_get_first_img().'</div>';
							} else {
								echo '<div class="text-attach post-content"><h1>'.get_the_title().'</h1>';
								echo $post->post_content;
								echo '</div>';
							} ?>
						<?php }?>
						<?php wp_reset_query();
						query_posts( array('post__in'=>$sticky_posts,'posts_per_page'=>6,'ignore_sticky_posts' => 1) );?>
						<div class = "glass"></div>
					</div>
				</div>
				<div id = "sticky-right-box" class = "slot">
					<div id = "sticky-border-box"></div>
					<?php while(have_posts()) {
						the_post(); ?>
						<div class = "sticky">
							<h1 class = "post-permalink"><a class = "sticky-permalink" href = "<?php the_permalink(); ?>" title = "<?php the_title(); ?>"><?php the_title(); ?></a></h1>
							<div class = "sticky-excerpt"><?php the_excerpt(); ?></div>
						</div>
					<?php } ?>
				</div>
			</div><!-- / sticky slider -->
		</div>
	<?php } ?>
	<?php wp_reset_query();
	$is_sticky=false;
}

function beverly_new_post_button() {
	if(current_user_can('publish_posts')) { ?>
		<!-- new post button -->
		<a class = "gal-box" href = "<?php echo admin_url('post-new.php'); ?>" id = "new-post-slide"></a>
		<!-- / new post button -->
	<?php }
}

/* Meta Box Callbacks */

function beverly_custom_excerpt_box( $post ) {
	wp_nonce_field( 'custom_excerpt_box', 'custom_excerpt_box_nonce' );
	$card_info = beverly_get_post_parts();
	_e('Select what you want show in excerpt:', 'Beverly' );
	echo '<br/><hr/><fieldset>';
	echo '<input id = "title-checkbox" type = "checkbox" value = "true" name = "title" '.checked($card_info['show_title'],true,false).'><label for = "title-checkbox">'.__('Title','Beverly').'</label><br />';
	echo '<input id = "author-checkbox" type = "checkbox" value = "true" name = "author" '.checked($card_info['show_author'],true,false).'><label for = "author-checkbox">'.__('Author','Beverly').'</label><br />';
	echo '<input id = "pubdate-checkbox" type = "checkbox" value = "true" name = "pubdate" '.checked($card_info['show_pubdate'],true,false).'><label for = "pubdate-checkbox">'.__('Publish date','Beverly').'</label><br />';
	echo '<input id = "cat-checkbox" type = "checkbox" value = "true" name = "category" '.checked($card_info['show_category'],true,false).'><label for = "cat-checkbox">'.__('Category','Beverly').'</label><br />';
	echo '<input id = "tags-checkbox" type = "checkbox" value = "true" name = "tags" '.checked($card_info['show_tags'],true,false).'><label for = "tags-checkbox">'.__('Tags','Beverly').'</label><br />';
	echo '<input id = "media-checkbox" type = "checkbox" value = "true" name = "media" '.checked($card_info['show_media'],true,false).'><label for = "media-checkbox">'.__('Media (Feautured image, video ...)','Beverly').'</label><br />';
	echo '<input id = "comments-checkbox" type = "checkbox" value = "true" name = "comments" '.checked($card_info['show_comments'],true,false).'><label for = "comments-checkbox">'.__('Comments','Beverly').'</label><br />';
	echo '<input id = "excerpt-checkbox" type = "checkbox" value = "true" name = "post_excerpt_x"  '.checked($card_info['show_excerpt'],true,false).'><label for = "excerpt-checkbox">'.__('Excerpt','Beverly').'</label><br />';
	echo '<input type = "hidden" name = "is_post_form" value = "true"></fieldset>';
}

/* Admin Menu Page Callbacks */

function beverly_settings_page_callback() { ?>
	<div class="wrap"><?php screen_icon() ?>
	<h2><?php _e('Theme Settings', 'Beverly'); ?></h2>
	<form method="post" action="options.php">
		<?php
			settings_fields('beverly_main_settings');
			do_settings_sections('beverly_settings');
			submit_button();
		?>
	</form>
	</div>
<?php }

function beverly_def_val_page_callback() { ?>
	<div class="wrap"><?php screen_icon() ?>
	<h2><?php _e('Default Values Settings', 'Beverly'); ?></h2>
	<form method="post" action="options.php">
		<?php
			settings_fields('beverly_def_val');
			do_settings_sections('beverly_def_val');
			submit_button();
		?>
	</form>
	</div>
<?php }

function beverly_own_styles_callback() {
	$options = get_option('beverly_main_settings');
	echo '<textarea name = "beverly_main_settings[own_styles]" rows = "10" class = "large-text code">'.$options['own_styles'].'</textarea>';
}

function beverly_own_script_callback() {
	$options = get_option('beverly_main_settings');
	echo '<fieldset><textarea name = "beverly_main_settings[own_script]" rows = "10" class = "large-text code">'.$options['own_script'].'</textarea>';
	beverly_settings_checkbox('footer-script', 'beverly_main_settings[footer_script]', $options['footer_script'], 'true', __('Append script to footer', 'Beverly'));
	echo '</fieldset>';
}

function beverly_favicon_callback() {
	$options = get_option('beverly_main_settings');
	echo "<input type = 'text' id = 'favicon_url_input' name = 'beverly_main_settings[favicon_url]' value = '{$options['favicon_url']}' placeholder = '".__('E. g. http://www.stepanvich.cz/favicon.ico','Beverly')."' size = '55' />";
}

function beverly_def_val_info_callback() {
	printf('<p>%s</p>',__('When you create new post, this values are default in custom post excerpt meta box.', 'Beverly'));
}

function beverly_def_val_checkboxes_callback() {
	$options = get_option('beverly_def_val');
	echo '<fieldset>';
	beverly_settings_checkbox('def_val_title', 'beverly_def_val[show_title]', $options['show_title'], true, __('Title','Beverly'));
	beverly_settings_checkbox('def_val_author', 'beverly_def_val[show_author]', $options['show_author'], true, __('Author','Beverly'));
	beverly_settings_checkbox('def_val_pubdate', 'beverly_def_val[show_pubdate]', $options['show_pubdate'], true, __('Publish date','Beverly'));
	beverly_settings_checkbox('def_val_excerpt', 'beverly_def_val[show_excerpt]', $options['show_excerpt'], true, __('Excerpt','Beverly'));
	beverly_settings_checkbox('def_val_tags', 'beverly_def_val[show_tags]', $options['show_tags'], true, __('Tags','Beverly'));
	beverly_settings_checkbox('def_val_media', 'beverly_def_val[show_media]', $options['show_media'], true, __('Media (Feautured image, video ...)','Beverly'));
	beverly_settings_checkbox('def_val_cat', 'beverly_def_val[show_category]', $options['show_category'], true, __('Category','Beverly'));
	beverly_settings_checkbox('def_val_comments', 'beverly_def_val[show_comments]', $options['show_comments'], true, __('Comments','Beverly'));

	echo '</fieldset>';
}

function beverly_sanitize_css($css) {
	$css = esc_html( $css );
	$css = str_replace( '&gt;', '>', $css );
	$css = str_replace( '&lt;', '<', $css );
	return $css;
}

function beverly_get_full_hex_color($hex_color) {
	return ( strlen($hex_color) == 3 ? $hex_color.$hex_color : $hex_color );
}

function beverly_get_cur_url() {
	return "http".($_SERVER["SERVER_PORT"] == 443 ? "s" : "") . "://" . $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"];
}

?>
