<?php
/*
 * The template for displaying image attachments.
 *
 * @package WordPress
 * @subpackage Beverly
 * @since Beverly 1.0
 */
?>

<?php get_header(); ?>
<?php get_sidebar(); ?>
<div class="right-box">
	<article <?php post_class();?>>
		<div class="slot">
			<div class="text-content">
				<h1><?php the_title();?></h1>
				<div class="post-meta">
					Posted on <span class="post-meta-cell"><?php beverly_the_date_archive();?></span> <span class="post-meta-cell"> by <?php the_author();?></span>
				</div>
				<div class="attachment-image">
					<?php echo wp_get_attachment_image(get_the_ID(),'medium'); ?>
				</div>
				<?php $metadata = wp_get_attachment_metadata();
				printf( '<span class="attachment-meta full-size-link"><a href="%1$s" title="%2$s"><span class="icon-full-size"></span>%3$s %4$s &times; %5$s</a></span>', esc_url( wp_get_attachment_url() ), esc_attr__( 'Link to full-size image', 'Beverly' ),'<span class = "icon-expand"></span>', $metadata['width'],$metadata['height']); ?>
				<?php if(get_the_excerpt()) { ?>
					<div class="attachment-excerpt">
						<?php the_excerpt();?>
					</div>
				<?php } ?>
				<div id="last-modified">
					<?php the_modified_date(get_option('date_format'),__('Last modified: ', 'Beverly')); ?>
				</div>
			</div>
			<div class = "pagination">
			<?php previous_image_link('medium', '<div class = "prev-post btn">&laquo '.__('Previous Image', 'Beverly').'</div>');
			next_image_link('medium', '<div class = "next-post btn">'.__('Next Image', 'Beverly').' &raquo</div>'); ?>
		</div>
		</div>
	</article>
</div>
<?php comments_template();?>
<?php get_footer();?>
