<?php
/*
 * The Template for displaying all single posts.
 *
 * @package WordPress
 * @subpackage Beverly
 * @since Beverly 1.0
 */
?>

<?php get_header(); ?>
<?php get_sidebar(); ?>
<?php $post_format = get_post_format(); ?>
<!-- right box -->
<div class = "right-box">
	<article <?php post_class();?> >
		<!-- slot -->
		<div class = "slot">
			<?php if (has_post_thumbnail()) { ?>
				<div id = "thumbnail-clip">
					<?php the_post_thumbnail('full'); ?>
				</div>
			<?php } ?>
			<!-- text content -->
			<div class = "text-content">
				<h1><?php the_title();?></h1>
				<div class = "post-meta">
					Posted on <span class = "post-meta-cell"><?php beverly_the_date_archive();?></span> <span class = "post-meta-cell"> by <?php the_author();?></span> <span class = "post-meta-cell"> in <span class ="category-list"><?php the_category(', ');?></span></span><br>
					<span class = "post-meta-cell"><span class = "icon-<?php if($post_format) {echo $post_format;} else {echo 'post';} ?>"></span><a href = "<?php echo get_post_format_link($post_format); ?>" class = "post-format-type"><?php echo get_post_format_string($post_format); ?></a></span>
				</div>
				<ul class="tags">
						<?php the_tags( "<li>", "</li><li>", "</li>" ); ?>
				</ul>
				<?php the_content();?>
				<div class = "inline-pagination">
					<?php wp_link_pages(); ?>
				</div>
				<div id = "last-modified">
					<?php the_modified_date(get_option('date_format'),__('Last updated ', 'Beverly')); ?>
				</div>
			</div><!-- / text content -->
			<div class = "pagination">
				<?php previous_post_link('<div class = "prev-post btn">%link</div>','&laquo %title'); next_post_link('<div class = "next-post btn">%link</div>','%title &raquo'); ?>
			</div>
		</div><!-- / slot -->
	</article>
</div><!-- / right box -->
<?php comments_template();?>
<?php get_footer();?>